# ToDo App
is a kind of app that generally used to maintain our day-to-day tasks or list everything that we have to do,
with the most important tasks at the top of the list, and the least important tasks at the bottom.
It is helpful in planning our daily schedules.

## Architecture
The architecture of this application relies and complies with the following points below:
- __A single-activity architecture__, using the Navigation Components to manage fragment operations.
- __Pattern Model-View-ViewModel (MVVM)__ which facilitates a separation of development of the graphical user interface.
- __Android architecture components__ which help to keep the application robust, testable, and maintainable.

![68747470733a2f2f646576656c6f7065722e616e64726f69642e636f6d2f746f7069632f6c69627261726965732f617
2636869746563747572652f696d616765732f66696e616c2d6172636869746563747572652e706e67](https://user-images.githubusercontent.com/54688005/183620846-45807b10-a59f-45f6-8ab6-b23ad2cf3a72.PNG)


## ScreenShots

<p float = "left">
<img src = "https://user-images.githubusercontent.com/54688005/183623208-61058172-b594-4f1f-b385-2b70fe7554d5.png" width = "35%">
<img src = "https://user-images.githubusercontent.com/54688005/183623262-44abea68-7577-4d88-941c-92ebb48af9e2.png" width = "35%">
<img src = "https://user-images.githubusercontent.com/54688005/183623174-89c3f940-1fce-4217-8023-562f523ae5fa.png" width = "35%">
<img src = "https://user-images.githubusercontent.com/54688005/183623286-9d13427a-5e0d-4110-bbd0-1c61593a3511.png" width = "35%">
<img src = "https://user-images.githubusercontent.com/54688005/183623230-0a0a557a-a7b2-4564-9272-fdbaf0cc9d9d.png" width = "35%">
<p/>

# Languages and Tools
* [Kotlin](https://kotlinlang.org/) - official programming language for Android development .
* [Coroutines](https://kotlinlang.org/docs/reference/coroutines-overview.html) - for asynchronous programming .
* [Android Architecture Components](https://developer.android.com/topic/libraries/architecture) - Collection of libraries that help you design robust, testable, and maintainable apps.
  - [LiveData](https://developer.android.com/topic/libraries/architecture/livedata) - Data objects that notify views when the underlying database changes.
  - [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel) - Stores UI-related data that isn't destroyed on UI changes. 
  - [Room](https://developer.android.com/topic/libraries/architecture/room) - Access your app's SQLite database with in-app objects and compile-time checks.
  - [Navigation Components](https://developer.android.com/guide/navigation) - the interactions that allow users to navigate across, into, and back out from the different pieces of content within your app
* [Fragment](https://developer.android.com/guide/components/fragments)
* [View Binding](https://developer.android.com/topic/libraries/view-binding) - more easily write code that interacts with views.
* [LeakCanary](https://square.github.io/leakcanary) - memory leak detection library for Android.
* [detekt](https://github.com/detekt/detekt) - Static code analysis for Kotlin.
* [Unit Testing](https://developer.android.com/training/testing/local-tests) - Build local unit tests.


## memory Leaks 
<img src = "https://user-images.githubusercontent.com/54688005/183884029-b9b53946-9cad-4097-9b04-463e12366f22.PNG" width = "75%">


## Unit Testing 
<img src = "https://user-images.githubusercontent.com/54688005/183884276-ffdeb29d-785c-430f-b62e-b924528d0e05.PNG" width = "75%">


# How to install and run the project.
You can download Apk from **release** section 




 
